#ifndef DICTIONARYOPTIONSDIALOG_H
#define DICTIONARYOPTIONSDIALOG_H

#include <QtCore>
#include <QtWidgets>

#include "../dictionary/Field.h"
#include "../dictionary/CardPack.h"
#include "../dictionary/Dictionary.h"

class Dictionary;
class FieldsListModel;

class DictionaryOptionsDialog : public QDialog
{
    Q_OBJECT

public:
    DictionaryOptionsDialog( Dictionary* aDict, QWidget* aParent );
    ~DictionaryOptionsDialog();
    QSize sizeHint() const;

private:
    void initData();
    void createPages();
    QLabel* createDictPathLabel();

public:
    FieldsListModel* m_fieldsListModel;
    Field* m_emptyField;
    Dictionary m_dict;

private:
    Dictionary* m_origDictPtr;
    QListWidget* m_contentsWidget;
    QTabWidget* m_pages;
};

Q_DECLARE_METATYPE(QList<QPersistentModelIndex>)

#endif // DICTIONARYOPTIONSDIALOG_H
