#ifndef FIELDSPAGE_H
#define FIELDSPAGE_H

#include <QListView>

#include "DictionaryOptionsDialog.h"
#include "FieldsView.h"

class Dictionary;
class QGroupBox;
class QVBoxLayout;

class FieldsPage : public QWidget
{
    Q_OBJECT
public:
    FieldsPage( DictionaryOptionsDialog* aParent );

private slots:
    void moveItemsUpDown();
    void addRow();
    void removeRows();
    void editField();

private:
    void createFieldsList();
    void createFieldsPreview();

private:
    DictionaryOptionsDialog* m_parent;
    QVBoxLayout* m_fieldsLt;
    QGroupBox* m_previewGroup;
    FieldsView* m_fieldsListView;
    QListView* m_fieldsPreview;
};

#endif
