#ifndef FIELDSPREVIEWMODEL_H
#define FIELDSPREVIEWMODEL_H

#include <QAbstractListModel>

#include "DictionaryOptionsDialog.h"
#include "../dictionary/Dictionary.h"

class FieldsPreviewModel : public QAbstractListModel
{
    Q_OBJECT

public:
    FieldsPreviewModel( DictionaryOptionsDialog* aParent ):
        QAbstractListModel( aParent ), m_parent( aParent )
        {}

    int rowCount( const QModelIndex& /*parent*/ = QModelIndex() ) const
        { return m_parent->m_dict.fieldsNum(); }
    QVariant data( const QModelIndex &index, int role = Qt::DisplayRole ) const;
    Qt::ItemFlags flags(const QModelIndex &/*index*/) const {return Qt::NoItemFlags;}

private:
    DictionaryOptionsDialog* m_parent;
};

#endif // FIELDSPREVIEWMODEL_H
