#include "FieldsView.h"
#include "FieldStyleDelegate.h"

#include <QHeaderView>

FieldsView::FieldsView(QWidget *parent):
    QTableView( parent )
    {
    setDragEnabled(true);
    setAcceptDrops(true);
    setDropIndicatorShown(true);
    setDragDropOverwriteMode( false );
    FieldStyleDelegate* delegate = new FieldStyleDelegate(this);
    setItemDelegateForColumn( 1, delegate );

    setShowGrid(false);
    verticalHeader()->hide();
    setSelectionBehavior( QAbstractItemView::SelectRows );
    }

void FieldsView::startDrag(Qt::DropActions supportedActions)
    {
    selectionModel()->select( selectionModel()->selection(),
        QItemSelectionModel::Select | QItemSelectionModel::Rows );
    QAbstractItemView::startDrag( supportedActions );
    }

void FieldsView::setModel( FieldsListModel* aModel )
    {
    QTableView::setModel( aModel );
    qRegisterMetaType< QList<QPersistentModelIndex> >();
    connect( aModel, SIGNAL(indexesDropped(QList<QPersistentModelIndex>)),
        this, SLOT(selectIndexes(QList<QPersistentModelIndex>)), Qt::QueuedConnection );
    }

void FieldsView::selectIndexes( QList<QPersistentModelIndex> aIndexes )
    {
    selectionModel()->clearSelection();
    foreach( QPersistentModelIndex pIndex, aIndexes )
        selectionModel()->select( pIndex, QItemSelectionModel::Select | QItemSelectionModel::Rows );
    }
