#ifndef PACKFIELDSLISTMODEL_H
#define PACKFIELDSLISTMODEL_H

#include <QAbstractListModel>

#include "DictionaryOptionsDialog.h"
#include "DraggableListModel.h"
#include "../dictionary/Dictionary.h"

class PackFieldsListModel : public DraggableListModel
{
    Q_OBJECT

public:
    PackFieldsListModel( DictionaryOptionsDialog* aParent ):
        DraggableListModel( aParent ), m_parentRow( 0 )
        {}

    int rowCount( const QModelIndex& parent = QModelIndex() ) const;
    QVariant data( const QModelIndex &index, int role = Qt::DisplayRole ) const;
    bool setData(const QModelIndex& index, const QVariant& aValue, int role = Qt::EditRole );
    bool insertRows(int position, int rows, const QModelIndex &);
    bool removeRows(int position, int rows, const QModelIndex &);
    const void* dataPtr( const QModelIndex& aIndex ) const;
    void insertPointer( int aPos, void* aData );

public slots:
    void changeParentRow( const QModelIndex& aIndex );

private:
    int m_parentRow;
};

#endif
