#ifndef PACKSLISTMODEL_H
#define PACKSLISTMODEL_H

#include <QAbstractListModel>

#include "DictionaryOptionsDialog.h"
#include "DraggableListModel.h"
#include "../dictionary/Dictionary.h"

class PacksListModel : public DraggableListModel
{
    Q_OBJECT

public:
    PacksListModel( DictionaryOptionsDialog* aParent ):
        DraggableListModel( aParent )
        {}

    int rowCount( const QModelIndex& /*parent*/ = QModelIndex() ) const
        { return m_parent->m_dict.cardPacksNum(); }

    QVariant data( const QModelIndex &index, int role ) const;
    bool setData(const QModelIndex& index, const QVariant& aValue, int role = Qt::EditRole );
    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool insertRows(int position, int rows, const QModelIndex &);
    bool removeRows(int position, int rows, const QModelIndex &);
    const void* dataPtr( const QModelIndex& aIndex ) const;
    void insertPointer( int aPos, void* aData );
    void removePack( int aPos );
};

#endif
