#ifndef DICTIONARYWRITER_H
#define DICTIONARYWRITER_H

#include <QXmlStreamWriter>

class Dictionary;
class Field;
class CardPack;
class DicRecord;

class DictionaryWriter : public QXmlStreamWriter
{
public:
    DictionaryWriter( const Dictionary* aDict );
    bool write( QIODevice* aDevice );

private:
    void writeField( Field* aField );
    void writePack( const CardPack* aPack );
    void writeEntry( const DicRecord* aEntry, QList<Field*> aFields );

private:
    const Dictionary* m_dict;
};

#endif // DICTIONARYWRITER_H
