#ifndef ICARDPACK_H
#define ICARDPACK_H

#include <QString>
#include <QList>

#include "../study/StudyRecord.h"

class DicRecord;
class Field;

class ICardPack
{
public:
    static const QString SynonymDelimiter;
    static const QString HomonymDelimiter;

public:
    virtual ~ICardPack() {}

    virtual void addStudyRecord(const QString aCardId,
        const StudyRecord& aStudyRecord) = 0;
    virtual QList<StudyRecord> getStudyRecords(QString cardId) const = 0;
    virtual StudyRecord getStudyRecord(QString cardId) const = 0;

    virtual QList<DicRecord*> getRecords() const = 0;
    virtual const Field* getQuestionField() const = 0;
    virtual QList<const Field*> getAnswerFields() const = 0;
    QString getQuestionFieldName() const;
    QStringList getAnswerFieldNames() const;
};

#endif
