#ifndef CSVDATA_H
#define CSVDATA_H

#include <QtCore>

enum FieldSeparationMode
{
    EFieldSeparatorAnyCharacter = 0,
    EFieldSeparatorAnyCombination,
    EFieldSeparatorExactString
};

struct CsvParams
{
    QString fieldSeparators;
    QChar textDelimiter;
    QChar commentChar;
};

struct CsvImportData: public CsvParams
{
    QTextCodec* textCodec;
    int fromLine;
    bool firstLineIsHeader;
    FieldSeparationMode fieldSeparationMode;
    int colsToImport;  // 0 = All columns
};

struct CsvExportData: public CsvParams
{
    QList<int> usedCols;   // Empty = use all columns
    bool quoteAllFields;
    bool writeColumnNames;
};

#endif
