#ifndef DICTTABLEVIEW_h
#define DICTTABLEVIEW_h

#include <QTableView>
#include <QtDebug>

class DictTableModel;

class DictTableView: public QTableView
{
Q_OBJECT

public:
    DictTableView( QAbstractItemModel* aModel, QWidget* aParent = 0 );
    virtual ~DictTableView();
    void resizeColumnsToContents();
    DictTableModel* dicTableModel() const;
    void startEditing(int row, int col);
    void commitEditing();
    int getEditorCursorPos() const;
    void insertImageIntoEditor(int cursorPos, const QString& filePath) const;

private slots:
    void enableUpdates() { setUpdatesEnabled(true); }
    void disableUpdates() { setUpdatesEnabled(false); }

signals:
    void destroyed( QAbstractItemModel* aDictModel );

private:
    static const int KMinColWidth = 170;
    static const int KMaxColWidth = 400;
    static const int RowHeight = 27;
};

#endif
