#ifndef DICTIONARYTABWIDGET_H
#define DICTIONARYTABWIDGET_H

#include <QtCore>
#include <QtWidgets>

class MainWindow;
class FilterBar;
class DictTableModel;
class DictTableView;
class Dictionary;

class DictionaryTabWidget : public QTabWidget
{
    Q_OBJECT
public:
    DictionaryTabWidget(MainWindow* aMainWin);

    int addDictTab( DictTableModel* aDictModel );
    void setCurrentIndex( int aTabIx );
    void goToDictionaryRecord( int aDictIx, int aRecordRow );
    void cleanUndoStack();
    void showContinueSearch();
    
    const DictTableView* curDictView() const;
    QUndoGroup* undoGroup() const { return m_undoGroup; }
    bool undoStackIsClean() const;
    bool isInEditingState() const { return createdEditorsNum > 0; }

public slots:
    void closeTab( int aIndex = -1 );

private slots:
    void createEditor();
    void destroyEditor();

signals:
    void editingStateChanged();

private:
    MainWindow* m_mainWin;  // parent, now own
    QUndoGroup* m_undoGroup;
    QLabel* m_continueLbl;  // Continue search icon
    int createdEditorsNum;
};
#endif // DICTIONARYTABWIDGET_H
