#ifndef PACKSTREEMODEL_H
#define PACKSTREEMODEL_H

#include <QAbstractItemModel>

#include "../dictionary/CardPack.h"

class AppModel;

class PacksTreeModel : public QAbstractItemModel
{
    Q_OBJECT

public:
    PacksTreeModel( AppModel* aAppModel, QObject* aParent = 0);

    QVariant data( const QModelIndex &index, int role ) const;
    Qt::ItemFlags flags( const QModelIndex &index ) const;
    QVariant headerData( int section, Qt::Orientation orientation, int role = Qt::DisplayRole ) const;
    QModelIndex index( int row, int column, const QModelIndex &parent = QModelIndex() ) const;
    QModelIndex parent( const QModelIndex &index ) const;
    int rowCount( const QModelIndex &parent = QModelIndex() ) const;
    int columnCount( const QModelIndex &/*parent*/ = QModelIndex() ) const { return 3; }

public slots:
    void updateData();

private:
    AppModel* m_appModel;
};

#endif // PACKSTREEMODEL_H
