#include "ColorBox.h"

ColorBox::ColorBox( QColor aColor )
    {
    setAutoFillBackground(true);
    setFrameStyle( QFrame::Box );
    setLineWidth(2);
    setMinimumHeight( MinHeight );
    setMinimumWidth( MinWidth );
    setColor( aColor );
    }

void ColorBox::setColor( QColor aColor )
    {
    m_color = aColor;
    if( isEnabled() )
        setPalette( m_color );
    else
        setPalette( Qt::lightGray );
    }

void ColorBox::mousePressEvent(QMouseEvent* /*event*/)
    {
    QColor c = QColorDialog::getColor( color(), this );
    if( c.isValid() )
        {
        setColor( c );
        emit colorChanged( c );
        }
    }

void ColorBox::changeEvent ( QEvent* event )
    {
    if( event->type() == QEvent::EnabledChange )
        setColor( m_color );
    }
