#ifndef STYLESPREVIEWMODEL_H
#define STYLEPREVIEWMODEL_H

#include "../field-styles/FieldStyleFactory.h"
#include "FontColorSettingsDialog.h"

#include <QAbstractTableModel>

class StylePreviewModel : public QAbstractTableModel
{
    Q_OBJECT

public:
    StylePreviewModel( FontColorSettingsDialog* aParent ):
        m_parent( aParent )
        {}

    int rowCount( const QModelIndex& /*parent*/ = QModelIndex() ) const
        { return m_parent->styleFactory()->getStyleNames().size(); }
    int columnCount( const QModelIndex& /*parent*/ = QModelIndex() ) const
        { return 2; }
    QVariant data( const QModelIndex &index, int role = Qt::DisplayRole ) const;
    QVariant headerData( int /*section*/, Qt::Orientation /*orientation*/, int /*role = Qt::DisplayRole*/ ) const
        { return QVariant(); }
    Qt::ItemFlags flags(const QModelIndex &/*index*/) const {return Qt::NoItemFlags;}

private:
    FontColorSettingsDialog* m_parent;

};

#endif
