#ifndef CARDEDITDIALOG_H
#define CARDEDITDIALOG_H

#include <QDialog>
#include <QEvent>

class Card;
class Dictionary;
class CardFilterModel;
class DictTableView;
class DictTableModel;
class MainWindow;
class IStudyWindow;

class CardEditDialog : public QDialog
{
    Q_OBJECT
    
public:
    CardEditDialog(Card* aCurCard, MainWindow* aMainWindow, IStudyWindow* aStudyWindow);
    ~CardEditDialog();
    
    const DictTableView* cardEditView() const;    
    
protected:
    void closeEvent( QCloseEvent* event );
    bool event( QEvent* event );

private slots:
    void goToDictionaryWindow();    
        
private:
    static const int CardEditViewHeight = 130;
    static const int CardEditViewWidth = 600;
    
    const Dictionary* m_dictionary;
    CardFilterModel* m_cardEditModel;
    DictTableView* m_cardEditView;
    MainWindow* m_mainWindow;
};

#endif
