#ifndef CARDSSTATUSBAR_H
#define CARDSSTATUSBAR_H

#include <QtWidgets>

class CardsStatusBar : public QWidget
{
    Q_OBJECT
public:
    static const QStringList Colors;

public:
    CardsStatusBar(QWidget* aParent = 0);
    ~CardsStatusBar();
    void setValues(const QList<int>& values) { this->values = values; update(); }

protected:
    virtual void paintEvent(QPaintEvent* aEvent);

private:
    int getMax() const;
    void drawSection(int index);
    QLinearGradient getSectionGradient(int index);
    QRectF getSectionRect(int index);

private:
    static const int Radius = 6;

private:
    QList<int> values;
    qreal max;
    QRectF barRect;
    QPainter* painter;
    qreal sectionLeft;
};

#endif
