#ifndef STUDYFILEWRITER_H
#define STUDYFILEWRITER_H

#include <QXmlStreamWriter>
#include <QString>
#include <QList>

#include "StudyRecord.h"

class Dictionary;
class CardPack;

class StudyFileWriter : public QXmlStreamWriter
{
public:
    StudyFileWriter( const Dictionary* aDict );
    bool write( QIODevice* aDevice );

private:
    void writePack( const CardPack* aPack );
    void writeCard(const QString& aCardId, const CardPack* aPack );
private:
    const Dictionary* m_dict;
};

#endif // STUDYFILEWRITER_H
