#ifndef STUDYSETTINGS_H
#define STUDYSETTINGS_H

#include <QSettings>

class StudySettings
{
public:
    static StudySettings* inst();

public:
    StudySettings();
    void save();
    void load();

private:
    void loadUserSettings();
    void initDefaultStudy();
    void loadStudy(const QSettings& settings);

public:
    bool showRandomly;
    double newCardsShare;
    double schedRandomness;
    int cardsDayLimit;
    int newCardsDayLimit;
    int limitForAddingNewCards;
    int dayShift;   // in hours
    double initEasiness;
    double minEasiness;
    double maxEasiness;
    double difficultDelta;
    double easyDelta;
    double unknownInterval;
    double incorrectInterval;
    double learningInterval;    // Long learning level
    double nextDayInterval;     // first repetition
    double twoDaysInterval;     // easy first repetition
};
#endif
