#ifndef WORDDRILLWINDOW_H
#define WORDDRILLWINDOW_H

#include <QtWidgets>
#include "IStudyWindow.h"

class WordDrillModel;

class WordDrillWindow: public IStudyWindow
{
    Q_OBJECT

public:
    WordDrillWindow( WordDrillModel* aModel, QWidget* aParent );
    ~WordDrillWindow();

protected:
    QVBoxLayout*  createLowerPanel();
    void setStateForNextCard();
    void processState();
    void ReadSettings();
    void WriteSettings();

private:
    void DisplayCardNum();
    void UpdateButtons();

private slots:
    void ToggleAnswer();

private:
    static const int PosX = 200;
    static const int PosY = 200;
    static const int Width = 600;
    static const int Height = 350;

private:
    QLabel* iCardNumLabel;
    QProgressBar* iProgressBar;
    QCheckBox* iShowAnswersCB;
    QPushButton* iBackBtn;
    QPushButton* iForwardBtn;
    QPushButton* iNextBtn;
};

#endif
